10   CLS:DIM A(20,20,4),D(20,20,4),E(20,20,4),B(4),X(21),P(21)
20 KEY OFF
30 IP=57.29577951308402#
40 KEY 1, "a":KEY 2 ,"b":KEY 3 ,"c":KEY 4 ,"d"
50 COLOR 1,0:CLS:COLOR 15,1
60        PRINT"****************************************":                                PRINT"*                                      *":
70        PRINT"*  (C) 1986, SCIENCE SPECIALISTS INC   *":                                PRINT"*                                      *":                                PRINT"*      MATRIX INVERSION WITH           *"
80        PRINT"*      COMPLEX COEFFICIENTS            *":                                PRINT"*                                      *":                                PRINT"****************************************"
90 COLOR 15,0:LOCATE 24,1:PRINT"(Please activate 'Num Lock' to insure proper cursor control)";
100 LOCATE 9,1:PRINT:DW=1
110 IF DW>1 OR DW<0 THEN 50
120 PRINT"ENTER # OF ROWS (SQUARE MATRIX ASSUMED)? ";:GOSUB 1930:N=VAL(R$):IF N>25 OR N<2 THEN 50
125'===zero the two arrays===..   h=1&2 rectangular  h=3&4 polar
130 FOR R=1 TO N:FOR C=1 TO N:FOR H=1 TO 4:A(R,C,H)=0:D(R,C,H)=0:E(R,C,H)=0:NEXT:IF R=C THEN E(R,C,1)=1
140 NEXT:NEXT
150 GOSUB 1170
160 IF DW=1 THEN 180
170 GOSUB 2060
180 CLS:PRINT"WORKING-
190 FOR C=1 TO N
200 LOCATE 2,1:PRINT"COLUMN REDUCTION, COLUMN ";C
210 SS=0:FOR R=C TO N
220 FI=(A(R,C,1)^2+A(R,C,2)^2)
225'===Check through all values of a particular column to find the biggest value
230 IF FI>SS THEN NJI=R:SS=FI:'===memorize that value and row
240 NEXT R
250 IF SS<>0 THEN R=NJI:GOTO 280:'===if no value was found declare a misdeal
260 PRINT"NO INVERSE":GOTO 860
270 ' SWAP ANY NON-ZERO ROW FOR ROW ON DIAGONAL
280 IF C=N THEN 330 :'if you are down to the corner skip the swap
290 FOR V=1 TO N :'set up a column counter for the swap
295 'swap the current row with the predicted high row
300 B(1)=A(C,V,1):B(2)=A(C,V,2):B(3)=E(C,V,1):B(4)=E(C,V,2):A(C,V,1)=A(R,V,1):A(C,V,2)=A(R,V,2):E(C,V,1)=E(R,V,1):E(C,V,2)=E(R,V,2)
310 A(R,V,1)=B(1):A(R,V,2)=B(2):E(R,V,1)=B(3):E(R,V,2)=B(4)
320 NEXT V
330 FOR S=C TO N:IF (A(S,C,1)=0) AND (A(S,C,2)=0) THEN 410
340 FOR T=N TO C STEP -1
350 ' UNITIZE ALL COLUMN 1 ENTRIES
360 M=A(S,T,1):ZN=A(S,T,2):O=A(S,C,1):P=A(S,C,2):GOSUB 610:A(S,T,1)=M:A(S,T,2)=ZN
370 NEXT T
380 FOR T=1 TO N
390 M=E(S,T,1):ZN=E(S,T,2):GOSUB 610:E(S,T,1)=M:E(S,T,2)=ZN
400 NEXT T
410 NEXT S
420 IF C=N THEN 510
430 FOR S=C+1 TO N
440 FOR T=1 TO N
450 IF (A(S,C,1)<>0) OR (A(S,C,2)<>0) THEN E(S,T,1)=E(S,T,1)-E(C,T,1):E(S,T,2)=E(S,T,2)-E(C,T,2)
460 NEXT T
470 FOR T=N TO C STEP-1:' CANCEL ALL OTHER COLUMN 1 ENTRIES
480 IF (A(S,C,1)<>0) OR (A(S,C,2)<>0) THEN A(S,T,1)=A(S,T,1)-A(C,T,1):A(S,T,2)=A(S,T,2)-A(C,T,2)
490 NEXT T
500 PRINT:NEXT S
510 NEXT C
520 FOR C=N TO 1 STEP -1
530 FOR R=C-1 TO 1 STEP -1
540 M=A(R,C,1):ZN=A(R,C,2):O=A(C,C,1):P=A(C,C,2):GOSUB 610:CC=M:HH=ZN
550 FOR TS=1 TO N
560 M=CC:ZN=HH:O=E(C,TS,1):P=E(C,TS,2):GOSUB 620
570 E(R,TS,1)=E(R,TS,1)-M
580 E(R,TS,2)=E(R,TS,2)-ZN
590 NEXT TS
600 NEXT:NEXT:GOTO 630
610 K=(P*ZN+O*M)/(P^2+O^2):L=(O*ZN-P*M)/(P^2+O^2):M=K:ZN=L:RETURN
620 K=(O*M-P*ZN):L=ZN*O+M*P:M=K:ZN=L:RETURN
630 'PRINT ROUTINE
640 CLS:PRINT"============================= INVERSE MATRIX =================================="
650 K=0:COLOR 15,5
660 IF DW=1 THEN 700
670 LPRINT"***************************** INVERSE MATRIX **********************************"
680 LPRINT TAB(11);"REAL";TAB(26);"IMAGINARY";
690 LPRINT TAB(41);"MAGNITUDE";TAB(56);"PHASE"
700 PRINT TAB(11);"REAL";TAB(26);"IMAGINARY";
710 PRINT TAB(41);"MAGNITUDE";TAB(56);"PHASE                  "
720 FOR R=1 TO N
730 PRINT"------------------------------------------------------------------------------":FOR C=1 TO N
740 X(R)=SQR((E(R,C,1))^2+(E(R,C,2))^2)
750 IF E(R,C,1)=0 THEN PA=90*SGN(E(R,C,2)):GOTO 770
760 PA=ATN(E(R,C,2)/E(R,C,1))*IP
770 IF E(R,C,1)<0 THEN 780 ELSE 790
780 P(R)=PA+180:GOTO 800
790 P(R)=PA
800 P(R)=INT(P(R)*10000+.5)/10000
810 PRINT"R";RIGHT$(STR$(R),LEN(STR$(R))-1);" /C";RIGHT$(STR$(C),LEN(STR$(C))-1);" ";TAB(11);E(R,C,1);TAB(25);E(R,C,2);TAB(40);X(R);TAB(55);P(R);:WHILE POS(J)<79 :PRINT" ";:WEND:PRINT
820 IF DW=1 THEN 850
830 IF C=1 THEN LPRINT"                         ----ROW=";R;"----"
840 LPRINT"COL=";C;" ";TAB(11);E(R,C,1);TAB(26);E(R,C,2);TAB(41);X(R);TAB(56);P(R)
850 NEXT C:GOSUB 2160:NEXT R
860 COLOR 15,0:PRINT"================================================================================":IF DW=1 THEN 880 ELSE 870
870 LPRINT"*******************************************************************************":DW=1:lprint chr$(12)
880 PRINT"1=VIEW ORIGINAL MATRIX DATA"
890 PRINT"2=SEND DATA TO PRINTER"
900 PRINT"3=EDIT AND RECALCULATE INVERSE MATRIX"
910 PRINT"4=ENTER NEW DATA SET"
920 PRINT"5=VIEW INVERSE MATRIX DATA"
930 PRINT"6=EXIT"
940 PRINT" ? ";:GOSUB 1930:CHOICE=VAL(R$)
950 ON CHOICE GOTO 1100,960,980,50,630,1090:GOTO 1100
960 GOSUB 1025:DW=0
970 GOSUB 2060:GOTO 630
980 CLS
990 GOSUB 1030
1000 GOSUB 1170:CLS:GOTO 160
1010 INPUT"IMAGINARY";A(R,A,2):D(R,A,2)=A(R,A,2)
1020 GOTO 160
1025 FOR R=1 TO N:FOR C=1 TO N:A(R,C,1)=D(R,C,1):A(R,C,2)=D(R,C,2):NEXT:NEXT:RETURN
1030 FOR R=1 TO N:FOR C=1 TO N:A(R,C,1)=D(R,C,1):A(R,C,2)=D(R,C,2):E(R,C,1)=0:E(R,C,2)=0
1040 IF R=C THEN E(R,C,1)=1
1050 NEXT :NEXT:RETURN
1060 FOR R=1 TO N:FOR C=1 TO N:E(R,C,1)=0:E(R,C,2)=0:D(R,C,1)=A(R,C,1):D(R,C,2)=A(R,C,2)
1070 IF R=C THEN E(R,C,1)=1
1080 NEXT:NEXT:RETURN
1090 END
1100 GOSUB 1025:CLS:PRINT"=============================ORIGINAL MATRIX DATA==============================":COLOR 15,5:FOR R=1 TO N:PRINT "******************************  ROW ";R;TAB(42);"**************************************"
1110 FOR A=1 TO N
1120 IF A(R,A,2)=>0 THEN PRINT "COL=";A;"  (";A(R,A,1);" + ";ABS(A(R,A,2));"*J)";TAB(65);"               "
1130 IF A(R,A,2)<0 THEN PRINT  "COL=";A;"  (";A(R,A,1);" - ";ABS(A(R,A,2));"*J)";TAB(65);"               "
1140 NEXT:GOSUB 2160
1150 NEXT:COLOR 15,0:PRINT"*******************************************************************************":GOTO 880
1170 ROW=1:COL=1:EQN=1:RRR=1:CCC=1:GOSUB 1580:GOSUB 1730
1180 K$="":R$=""
1190 LOCATE 22,12
1200 K$="":K$=INKEY$:IF K$="" THEN 1200
1210 IF right$(K$,1)="M" THEN GOSUB 1830:GOTO 1200
1220 IF right$(K$,1)="P" THEN GOSUB 1860:GOTO 1200
1230 IF right$(K$,1)="H" THEN GOSUB 1770:GOTO 1200
1240 IF right$(K$,1)="K" THEN GOSUB 1800:GOTO 1200
1250 IF K$=CHR$(8) THEN GOSUB 1890
1260 IF K$=CHR$(13) THEN GOSUB 1310:GOTO 1190
1270 IF (K$="I") OR (K$="i") THEN KEY OFF:GOSUB 1060:RETURN
1280 LOCATE 22,12:PRINT"                "
1290 R$=R$+K$:LOCATE 22,12:PRINT R$
1300 GOTO 1190
1310 LOCATE 22,12:PRINT"                "
1320 DD=VAL(R$):R$=""
1330 A(EQN,ROW,COL)=DD:D(EQN,ROW,COL)=DD
1340 IF (COL=1) OR (COL=2) THEN 1380 ELSE 1350
1350 A(EQN,ROW,1)=A(EQN,ROW,3)*COS(A(EQN,ROW,4)/IP)
1360 A(EQN,ROW,2)=A(EQN,ROW,3)*SIN(A(EQN,ROW,4)/IP)
1370 GOTO 1420
1380 A(EQN,ROW,3)=SQR(A(EQN,ROW,1)^2+A(EQN,ROW,2)^2)
1390 IF A(EQN,ROW,1)=0 THEN A(EQN,ROW,4)=90*SGN(A(EQN,ROW,2)):GOTO 1420
1400 A(EQN,ROW,4)=ATN(A(EQN,ROW,2)/A(EQN,ROW,1)):IF A(EQN,ROW,1)<0 THEN A(EQN,ROW,4)=A(EQN,ROW,4)+3.141592653589#
1410 A(EQN,ROW,4)=A(EQN,ROW,4)*IP
1420 LOCATE ROW+3,15:PRINT"                                                           "
1430 FOR C=1 TO 4
1440 LOCATE ROW+3,C*15:PRINT A(EQN,ROW,C):NEXT
1450 IF (COL=1) OR (COL=3) THEN COL=COL+1:GOTO 1470
1460 IF (COL=2) OR (COL=4) THEN COL=COL-1:ROW=ROW+1
1470 GOSUB 1490
1480 RETURN
1490 BAG=0:IF COL>4 THEN COL=1:ROW=ROW+1
1500 IF COL<1 THEN COL=4:ROW=ROW-1
1510 IF ROW>N THEN ROW=1:EQN=EQN+1:BAG=1
1520 IF ROW<1 THEN ROW=N:EQN=EQN-1:BAG=1
1530 IF EQN>N THEN EQN=1:BAG=1:BEEP
1540 IF EQN<1 THEN EQN=N:BAG=1:BEEP
1550 IF BAG=1 THEN 1580
1560 GOSUB 1730
1570 RETURN
1580 CLS
1590 FOR R=1 TO N
1600  LOCATE R+3,1
1610 PRINT"COL=";R;
1620 FOR C=1 TO 4
1630 LOCATE R+3,C*15:PRINT A(EQN,R,C)
1640 NEXT
1650 NEXT
1660 LOCATE 1,1:PRINT"ROW # ";EQN
1670 PRINT TAB(15);"REAL";TAB(30);"IMAGINARY";
1680 PRINT TAB(45);"MAGNITUDE";TAB(60);"PHASE  "
1690 COLOR 15,3:LOCATE 24,13:PRINT"I=begin inversion; Return=accept entry;arrow keys=Cursor Control";:COLOR 15,0
1700 LOCATE 22,1:PRINT "   INPUT:"
1710 GOSUB 1730
1720 RETURN
1730 LOCATE RRR+3,CCC*15-2:PRINT " "
1740 COLOR 14,0:LOCATE ROW+3,COL*15-2:PRINT CHR$(219):COLOR 15,0
1750 RRR=ROW:CCC=COL
1760 RETURN
1770 ROW=ROW-1
1780 GOSUB 1490
1790 RETURN
1800 COL=COL-1
1810 GOSUB 1490
1820 RETURN
1830 COL=COL+1
1840 GOSUB 1490
1850 RETURN
1860 ROW=ROW+1:K$="":R$=""
1870 GOSUB 1490
1880 RETURN
1890 IF LEN(R$)>0 THEN R$=LEFT$(R$,LEN(R$)-1):K$="":GOSUB 1490:RETURN
1900 RETURN 1190
1910 IF LEN(R$)>0 THEN R$=LEFT$(R$,LEN(R$)-1)
1920 K$="":RETURN 2030
1930 RIB=POS(X):PIB=CSRLIN:K$="":R$=""
1940 REM key entry
1950 LOCATE PIB,RIB
1960 K$=INKEY$
1970 IF K$=CHR$(8) THEN GOSUB 1910
1980 IF K$<>"" THEN 2020
1990 NBN=NBN+1:IF NBN>0 THEN BNB=219 ELSE BNB=32
2000 IF NBN>4 THEN NBN=-4
2010 LOCATE PIB,(RIB+1+LEN(R$)):PRINT CHR$(BNB);:GOTO 1960
2020 IF K$=CHR$(13) THEN LOCATE PIB,(RIB+1+LEN(R$)):PRINT"   ":RETURN
2030 LOCATE PIB,RIB:PRINT"                "
2040 R$=R$+K$:LOCATE PIB,RIB:PRINT R$;" ";CHR$(219)
2050 GOTO 1950
2060 REM ***** COEFFICIENT LIST *****
2070 LPRINT"***************************** ORIGINAL MATRIX *********************************"
2080 LPRINT TAB(11);"REAL";TAB(26);"IMAGINARY";
2090 LPRINT TAB(41);"MAGNITUDE";TAB(56);"PHASE"
2100 FOR R=1 TO N:LPRINT"                         ----ROW=";R;"----"
2110 FOR C=1 TO N
2120 LPRINT"COL=";C;"  ";TAB(11);A(R,C,1);TAB(26);A(R,C,2);TAB(41);A(R,C,3);TAB(56);A(R,C,4)
2130 NEXT C
2140 NEXT R
2150 RETURN
2160 IF CSRLIN>(23-N) THEN 2165 ELSE RETURN
2165 IF DW=1 THEN 2170 ELSE RETURN
2170 RT$=INKEY$:IF RT$="" THEN 2170 ELSE COLOR 15,0:CLS:COLOR 15,5:RETURN
